/**
 * Copyright (C) 2018-2022
 * All rights reserved, Designed By www.yixiang.co

 */
package co.yixiang.yshop.module.order.enums;

import lombok.AllArgsConstructor;
import lombok.Getter;

import java.util.stream.Stream;

/**
 * @author hupeng
 * 支付相关枚举
 */
@Getter
@AllArgsConstructor
public enum PayTypeEnum {

	ALI("alipay","支付宝支付","1"),
	ALI_APP("alipay_app","支付宝APP支付","1"),
	ALI_H5("alipay_h5","支付宝H5支付","1"),
	WEIXIN("weixin","微信支付","6"),
	WEIXIN_H5("weixin_h5","微信H5支付","4"),
	WEIXIN_APPLET("weixin_applet","微信小程序支付","3"),
	WEIXIN_APP("weixin_app","微信app支付","2"),
	YUE("yue","余额支付","10"),
	INTEGRAL("integral","积分兑换","11");


	private String value;
	private String desc;
	private String code;
	public static PayTypeEnum toType(String value) {
		return Stream.of(PayTypeEnum.values())
				.filter(p -> p.value.equals(value))
				.findAny()
				.orElse(null);
	}


}
