package co.yixiang.yshop.module.order.service.storeorder;

import cn.hutool.core.util.IdUtil;
import cn.hutool.core.util.NumberUtil;
import cn.hutool.core.util.ObjectUtil;
import cn.hutool.core.util.StrUtil;
import co.yixiang.yshop.framework.common.constant.ShopConstants;
import co.yixiang.yshop.framework.common.enums.OrderInfoEnum;
import co.yixiang.yshop.framework.common.enums.ShopCommonEnum;
import co.yixiang.yshop.framework.common.exception.ErrorCode;
import co.yixiang.yshop.framework.common.util.json.JsonUtils;
import co.yixiang.yshop.framework.common.util.servlet.ServletUtils;
import co.yixiang.yshop.module.cart.service.storecart.AppStoreCartService;
import co.yixiang.yshop.module.member.controller.app.user.vo.AppUserQueryVo;
import co.yixiang.yshop.module.member.dal.dataobject.user.MemberUserDO;
import co.yixiang.yshop.module.member.dal.dataobject.useraddress.UserAddressDO;
import co.yixiang.yshop.module.member.enums.BillDetailEnum;
import co.yixiang.yshop.module.member.service.user.MemberUserService;
import co.yixiang.yshop.module.member.service.useraddress.AppUserAddressService;
import co.yixiang.yshop.module.member.service.userbill.UserBillService;
import co.yixiang.yshop.module.message.enums.WechatTempateEnum;
import co.yixiang.yshop.module.message.mq.producer.WeixinNoticeProducer;
import co.yixiang.yshop.module.order.controller.app.order.param.AppComputeOrderParam;
import co.yixiang.yshop.module.order.controller.app.order.param.AppConfirmOrderParam;
import co.yixiang.yshop.module.order.controller.app.order.param.AppOrderParam;
import co.yixiang.yshop.module.order.controller.app.order.param.AppPayParam;
import co.yixiang.yshop.module.order.controller.app.order.vo.AppComputeVo;
import co.yixiang.yshop.module.order.controller.app.order.vo.AppConfirmOrderVo;
import co.yixiang.yshop.module.order.controller.app.order.vo.AppStoreOrderQueryVo;
import co.yixiang.yshop.module.order.controller.app.order.vo.PayInfo;
import co.yixiang.yshop.module.order.convert.storeorder.StoreOrderConvert;
import co.yixiang.yshop.module.order.dal.dataobject.storeorder.StoreOrderDO;
import co.yixiang.yshop.module.order.dal.dataobject.storeordercartinfo.StoreOrderCartInfoDO;
import co.yixiang.yshop.module.order.dal.dataobject.storeorderstatus.StoreOrderStatusDO;
import co.yixiang.yshop.module.order.dal.mysql.storeorder.StoreOrderMapper;
import co.yixiang.yshop.module.order.dal.mysql.storeorderstatus.StoreOrderStatusMapper;
import co.yixiang.yshop.module.order.dal.redis.order.OrderRedisDAO;
import co.yixiang.yshop.module.order.enums.*;
import co.yixiang.yshop.module.order.service.storeorder.dto.*;
import co.yixiang.yshop.module.order.service.storeordercartinfo.StoreOrderCartInfoService;
import co.yixiang.yshop.module.order.service.storeorderstatus.StoreOrderStatusService;
import co.yixiang.yshop.module.pay.PayContext;
import co.yixiang.yshop.module.pay.controller.admin.merchantdetails.vo.PayParam;
import co.yixiang.yshop.module.pay.dal.dataobject.merchantdetails.MerchantDetailsDO;
import co.yixiang.yshop.module.pay.service.merchantdetails.MerchantDetailsService;
import co.yixiang.yshop.module.pay.strategy.weixin.service.WxPayService;
import co.yixiang.yshop.module.pay.strategy.weixin.service.WxPayServiceUtils;
import co.yixiang.yshop.module.pay.strategy.weixin.skd.HttpKit;
import co.yixiang.yshop.module.pay.strategy.weixin.skd.PaymentApi;
import co.yixiang.yshop.module.pay.strategy.weixin.skd.PaymentKit;
import co.yixiang.yshop.module.pay.strategy.weixin.skd.RandomStringUtil;
import co.yixiang.yshop.module.product.controller.app.cart.vo.AppStoreCartQueryVo;
import co.yixiang.yshop.module.product.controller.app.couponrelation.vo.CartCouponVO;
import co.yixiang.yshop.module.product.controller.app.product.vo.AppStoreProductRespVo;
import co.yixiang.yshop.module.product.dal.dataobject.shippingtemplates.ShippingTemplatesDO;
import co.yixiang.yshop.module.product.dal.dataobject.shippingtemplatesfree.ShippingTemplatesFreeDO;
import co.yixiang.yshop.module.product.dal.dataobject.shippingtemplatesregion.ShippingTemplatesRegionDO;
import co.yixiang.yshop.module.product.dal.dataobject.storeproductreply.StoreProductReplyDO;
import co.yixiang.yshop.module.product.service.productcoupon.ProductCouponService;
import co.yixiang.yshop.module.product.service.productcouponrelation.AppCouponRelationService;
import co.yixiang.yshop.module.product.service.productcouponrelation.dto.CartCouponDto;
import co.yixiang.yshop.module.product.service.shippingtemplates.ShippingTemplatesService;
import co.yixiang.yshop.module.product.service.shippingtemplatesfree.ShippingTemplatesFreeService;
import co.yixiang.yshop.module.product.service.shippingtemplatesregion.ShippingTemplatesRegionService;
import co.yixiang.yshop.module.product.service.storeproduct.AppStoreProductService;
import co.yixiang.yshop.module.product.service.storeproductreply.AppStoreProductReplyService;
import com.alibaba.fastjson.JSON;
import com.alibaba.fastjson.JSONObject;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.egzosn.pay.spring.boot.core.PayServiceManager;
import com.egzosn.pay.spring.boot.core.bean.MerchantPayOrder;
import com.google.common.collect.Maps;
import lombok.extern.slf4j.Slf4j;
import org.apache.commons.collections4.MapUtils;
import org.apache.commons.lang3.StringUtils;
import org.redisson.api.RBlockingDeque;
import org.redisson.api.RDelayedQueue;
import org.redisson.api.RLock;
import org.redisson.api.RedissonClient;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Propagation;
import org.springframework.transaction.annotation.Transactional;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import java.math.BigDecimal;
import java.time.LocalDateTime;
import java.time.ZoneOffset;
import java.time.format.DateTimeFormatter;
import java.util.*;
import java.util.concurrent.TimeUnit;
import java.util.stream.Collectors;

import static co.yixiang.yshop.framework.common.exception.util.ServiceExceptionUtil.exception;
import static co.yixiang.yshop.framework.common.util.date.DateUtils.FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND;
import static co.yixiang.yshop.module.member.enums.ErrorCodeConstants.USER_ADDRESS_NOT_EXISTS;
import static co.yixiang.yshop.module.order.enums.ErrorCodeConstants.*;

/**
 * 订单 Service 实现类
 *
 * @author yshop
 */
@Slf4j
@Service
@Validated
public class AppStoreOrderServiceImpl extends ServiceImpl<StoreOrderMapper, StoreOrderDO> implements AppStoreOrderService {

    @Resource
    private StoreOrderMapper storeOrderMapper;
    @Resource
    private AppStoreCartService appStoreCartService;
    @Resource
    private AppUserAddressService appUserAddressService;
    @Resource
    private ShippingTemplatesService shippingTemplatesService;
    @Resource
    private ShippingTemplatesRegionService shippingTemplatesRegionService;
    @Resource
    private ShippingTemplatesFreeService shippingTemplatesFreeService;
    @Resource
    private MemberUserService memberUserService;
    @Resource
    private OrderRedisDAO orderRedisDAO;
    @Resource
    private AppStoreProductService appStoreProductService;
    @Resource
    private StoreOrderCartInfoService storeOrderCartInfoService;
    @Resource
    private StoreOrderStatusService storeOrderStatusService;
    @Resource
    private UserBillService billService;
    @Resource
    private AppStoreProductReplyService appStoreProductReplyService;
    @Resource
    private WeixinNoticeProducer weixinNoticeProducer;
    @Resource
    private RedissonClient redissonClient;
    @Resource
    private MerchantDetailsService merchantDetailsService;

    @Resource
    private AsyncStoreOrderService asyncStoreOrderService;

    @Resource
    private StoreOrderStatusMapper storeOrderStatusMapper;

    @Resource
    private AppCouponRelationService appCouponRelationService;

    @Resource
    private PayServiceManager manager;

    private static final String LOCK_KEY = "cart:check:stock:lock";
    private static final String STOCK_LOCK_KEY = "cart:do:stock:lock";


    /**
     * 返回订单确认数据
     *
     * @param uid 用户ID
     * @return ConfirmOrderVO
     */
    @Override
    public AppConfirmOrderVo confirmOrder(Long uid, AppConfirmOrderParam param) {
        Map<String, Object> cartGroup = appStoreCartService.getUserProductCartList(uid,
                param.getCartId(), ShopConstants.YSHOP_ONE_NUM);
        if (ObjectUtil.isNotEmpty(cartGroup.get("invalid"))) {
            throw exception(INVALID_PRODUCT);
        }
        if (ObjectUtil.isEmpty(cartGroup.get("valid"))) {
            throw exception(VALID_PRODUCT_EMPTY);
        }

        boolean deduction = false;
        boolean enableIntegral = true;

        //获取默认地址
        UserAddressDO userAddress = appUserAddressService.getOne(Wrappers.<UserAddressDO>lambdaQuery()
                .eq(UserAddressDO::getUid, uid)
                .eq(param.getAddressId() != null, UserAddressDO::getId, param.getAddressId())
                .eq(param.getAddressId() == null, UserAddressDO::getIsDefault, ShopCommonEnum.IS_DEFAULT.getValue()));

        List<AppStoreCartQueryVo> cartInfo = (List<AppStoreCartQueryVo>) cartGroup.get("valid");
        PriceGroupDto priceGroup = this.getOrderPriceGroup(cartInfo, userAddress, param.getCouponId());


        //缓存订单
        CacheDto cacheDTO = new CacheDto();
        cacheDTO.setCartInfo(cartInfo);
        cacheDTO.setPriceGroup(priceGroup);
        //订单信息redis缓存一个小时
        String cacheKey = orderRedisDAO.set(cacheDTO, uid);


        //获取用户信息
        AppUserQueryVo appUserQueryVo = memberUserService.getAppUser(uid);

        return AppConfirmOrderVo.builder()
                .addressInfo(userAddress)
                .cartInfo(cartInfo)
                .priceGroup(priceGroup)
                .userInfo(appUserQueryVo)
                .orderKey(cacheKey)
                .deduction(deduction)
                .enableIntegral(enableIntegral)
                .build();

    }

    /**
     * 订单信息
     *
     * @param unique 唯一值或者单号
     * @param uid    用户id
     * @return YxStoreOrderQueryVo
     */
    @Override
    public AppStoreOrderQueryVo getOrderInfo(String unique, Long uid) {
        LambdaQueryWrapper<StoreOrderDO> wrapper = new LambdaQueryWrapper<>();
        wrapper.and(
                i -> i.eq(StoreOrderDO::getOrderId, unique).or().eq(StoreOrderDO::getUnique, unique).or()
                        .eq(StoreOrderDO::getExtendOrderId, unique));
        if (uid != null) {
            wrapper.eq(StoreOrderDO::getUid, uid);
        }

        return StoreOrderConvert.INSTANCE.convert01(storeOrderMapper.selectOne(wrapper));
    }


    /**
     * 计算订单价格
     *
     * @param uid   用户uid
     * @param key   订单缓存key
     * @param param 计算订单参数
     * @return map
     */
    @Override
    public Map<String, Object> computedOrder(Long uid, String key, AppComputeOrderParam param) {
        //检查订单
        Map<String, Object> map = this.check(uid, key, param);
        if (OrderLogEnum.EXTEND_ORDER.getValue().equals(map.get("status"))) {
            return map;
        }
        CacheDto cacheDTO = orderRedisDAO.get(key, uid);
        if (ObjectUtil.isNull(cacheDTO)) {
            throw exception(ORDER_EXPIRED);
        }

        //处理运费模板
        UserAddressDO userAddress = null;
        if (StrUtil.isNotBlank(param.getAddressId())) {
            userAddress = appUserAddressService.getById(param.getAddressId());
        }
        if (param.getCouponId() == null || param.getCouponId() == 0) {
            param.setCouponId(-1l);
        }
        PriceGroupDto priceGroup = this.getOrderPriceGroup(cacheDTO.getCartInfo(), userAddress, param.getCouponId());
        BigDecimal payPostage = priceGroup.getStorePostage();

        BigDecimal payPrice = priceGroup.getTotalPrice();

        //todo 折扣优惠券
        BigDecimal couponPrice = priceGroup.getCouponPrice();

        // 积分抵扣 todo
        BigDecimal deductionPrice = BigDecimal.ZERO; //积分抵扣金额
        double usedIntegral = 0; //使用了多少积分

        if (payPrice.compareTo(BigDecimal.ZERO) <= 0) {
            payPrice = BigDecimal.ZERO;
        }

        AppComputeVo appComputeVo = AppComputeVo.builder()
                .totalPrice(cacheDTO.getPriceGroup().getTotalPrice())
                .payPrice(payPrice)
                .payPostage(payPostage)
                .couponPrice(couponPrice)
                .deductionPrice(deductionPrice)
                .usedIntegral(usedIntegral)
                .payIntegral(cacheDTO.getPriceGroup().getPayIntegral())
                .build();

        map.put("result", appComputeVo);
        map.put("status", OrderLogEnum.NONE_ORDER.getValue());

        return map;
    }

    /**
     * 创建订单
     *
     * @param uid   用户uid
     * @param key   key
     * @param param param
     * @return YxStoreOrder
     */
    @Override
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public Map<String, Object> createOrder(Long uid, String key, AppOrderParam param) {
        AppComputeOrderParam appComputeOrderParam = AppComputeOrderParam.builder()
                .addressId(param.getAddressId())
                .couponId(param.getCouponId())
                .useIntegral(param.getUseIntegral())
                .shippingType(param.getShippingType())
                .build();
        Map<String, Object> map = this.computedOrder(uid, key, appComputeOrderParam);

        if (!OrderLogEnum.NONE_ORDER.getValue().equals(map.get("status"))) {
            return map;
        }
        AppComputeVo computeVo = (AppComputeVo) map.get("result");
        if (StrUtil.isEmpty(param.getAddressId())) {
            throw exception(SELECT_ADDRESS);
        }
        UserAddressDO userAddress = appUserAddressService.getById(param.getAddressId());
        if (ObjectUtil.isNull(userAddress)) {
            throw exception(USER_ADDRESS_NOT_EXISTS);
        }

        Integer totalNum = 0;
        List<String> cartIds = new ArrayList<>();

        CacheDto cacheDTO = orderRedisDAO.get(key, uid);
        List<AppStoreCartQueryVo> cartInfo = cacheDTO.getCartInfo();

        //对库存检查加锁
        RLock lock = redissonClient.getLock(LOCK_KEY);
        if (lock.tryLock()) {
            try {
                for (AppStoreCartQueryVo cart : cartInfo) {
                    //检测库存
                    appStoreCartService.checkProductStock(uid, cart.getProductId(), cart.getCartNum(), cart.getProductAttrUnique());

                    cartIds.add(cart.getId().toString());
                    totalNum += cart.getCartNum();
                }
            } catch (Exception ex) {
                log.error("[checkProductStock][执行异常]", ex);
                throw exception(new ErrorCode(999999, ex.getMessage()));
            } finally {
                lock.unlock();
            }
        }


        //计算奖励积分
        BigDecimal gainIntegral = this.getGainIntegral(cartInfo);
        //生成分布式唯一值
        String orderId = IdUtil.getSnowflake(0, 0).nextIdStr();
        //组合数据
        StoreOrderDO storeOrder = new StoreOrderDO();
        storeOrder.setUid(uid);
        storeOrder.setOrderId(orderId);
        storeOrder.setRealName(userAddress.getRealName());
        storeOrder.setUserPhone(userAddress.getPhone());
        storeOrder.setUserAddress(userAddress.getProvince() + " " + userAddress.getCity() +
                " " + userAddress.getDistrict() + " " + userAddress.getDetail());
        storeOrder.setCartId(StrUtil.join(",", cartIds));
        storeOrder.setTotalNum(totalNum);
        storeOrder.setTotalPrice(computeVo.getTotalPrice());
        storeOrder.setTotalPostage(computeVo.getPayPostage());

        storeOrder.setCouponId(param.getCouponId() != null && param.getCouponId().compareTo(0l) > 0 ? param.getCouponId() : null);
        storeOrder.setCouponPrice(computeVo.getCouponPrice());
        storeOrder.setPayPrice(computeVo.getPayPrice());
        storeOrder.setPayPostage(computeVo.getPayPostage());
        storeOrder.setDeductionPrice(computeVo.getDeductionPrice());
        storeOrder.setPaid(OrderInfoEnum.PAY_STATUS_UNPAID.getValue());
        //目前没传支付类型，默认类型微信
        //storeOrder.setPayType(PayTypeEnum.WEIXIN.getValue());
        storeOrder.setPayType("");
        storeOrder.setUseIntegral(BigDecimal.valueOf(computeVo.getUsedIntegral()));
        storeOrder.setBackIntegral(BigDecimal.ZERO);
        storeOrder.setGainIntegral(gainIntegral);
        storeOrder.setMark(param.getMark());
        storeOrder.setCost(cacheDTO.getPriceGroup().getCostPrice());
        storeOrder.setUnique(key);
        storeOrder.setShippingType(param.getShippingType());

        boolean res = this.save(storeOrder);
        if (!res) {
            throw exception(ORDER_GEN_FAIL);
        }

        // 减库存加销量
        this.deStockIncSale(cartInfo);

        if (param.getCouponId() != null && param.getCouponId() != 0 && param.getCouponId() != -1) {
            // 使用优惠券
            appCouponRelationService.verificationCoupon(param.getCouponId());
        }

        //保存购物车商品信息，异步执行
        storeOrderCartInfoService.saveCartInfo(storeOrder.getId(), storeOrder.getOrderId(), cartInfo);


        //购物车状态修改异步执行
        appStoreCartService.updateCartPayStatus(cartIds);


        //删除缓存
        orderRedisDAO.delete(key, uid);

        //增加状态
        storeOrderStatusService.create(uid, storeOrder.getId(), OrderLogEnum.CREATE_ORDER.getValue(),
                OrderLogEnum.CREATE_ORDER.getDesc());


        //加入延时队列，30分钟自动取消
        try {
            RBlockingDeque<Object> blockingDeque = redissonClient.getBlockingDeque(ShopConstants.REDIS_ORDER_OUTTIME_UNPAY_QUEUE);
            RDelayedQueue<Object> delayedQueue = redissonClient.getDelayedQueue(blockingDeque);
            delayedQueue.offer(orderId, ShopConstants.ORDER_OUTTIME_UNPAY, TimeUnit.MINUTES);
            String s = TimeUnit.SECONDS.toSeconds(ShopConstants.ORDER_OUTTIME_UNPAY) + "分钟";
            log.info("添加延时队列成功 ，延迟时间：" + s + "订单id: " + orderId);
        } catch (Exception e) {
            log.error(e.getMessage());
        }

        OrderExtendDto orderDTO = new OrderExtendDto();
        orderDTO.setKey(key);
        orderDTO.setOrderId(storeOrder.getOrderId());
        map.put("status", OrderLogEnum.CREATE_ORDER_SUCCESS.getValue());
        map.put("result", orderDTO);
        map.put("createTime", storeOrder.getCreateTime());


        return map;
    }

    /**
     * 第三方支付查单
     *
     * @param uid   用户id
     * @param param 订单参数
     * @return 支付结果
     */
    public Boolean orderQuery(Long uid, AppPayParam param) {
        AppStoreOrderQueryVo orderInfo = getOrderInfo(param.getUni(), uid);
        if (ObjectUtil.isNull(orderInfo)) {
            throw exception(STORE_ORDER_NOT_EXISTS);
        }
        if (orderInfo.getPayInfo() == null) {
            return false;
        }
        //paytype含有weixin就查微信订单
        if (param.getPaytype().contains(PayTypeEnum.WEIXIN.getValue())) {
            //微信查单
            MerchantDetailsDO merchantDetailsDO = merchantDetailsService.getMerchantDetails("4");
            if (merchantDetailsDO == null) throw exception(ORDER_QUERY_NO_MERCHANT);
            PayInfo payInfo = JsonUtils.parseObject(orderInfo.getPayInfo(), PayInfo.class);
            if (payInfo == null) return false;
            if (payInfo.getTransaction_id() == null) return false;
            Map<String, String> map = PaymentApi.queryByTransactionId(merchantDetailsDO.getAppid(), merchantDetailsDO.getMchId(), merchantDetailsDO.getKeyPrivate(), payInfo.getTransaction_id());
            log.info("查询到微信订单信息：" + map.toString());
            return map.get("return_code").equals("SUCCESS") && map.get("result_code").equals("SUCCESS") && map.get("trade_state").equals("SUCCESS");
        } else {
            //其他支付查单
            return false;
        }
    }

    /**
     * 第三方支付
     *
     * @param uid   用户id
     * @param param 订单参数
     * @return 支付结果
     */
    @Override
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public Map<String, String> pay(Long uid, AppPayParam param) throws Exception {
        AppStoreOrderQueryVo orderInfo = getOrderInfo(param.getUni(), uid);
        if (ObjectUtil.isNull(orderInfo)) {
            throw exception(STORE_ORDER_NOT_EXISTS);
        }
        if (orderInfo.getPaid().equals(OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue())) {
            throw exception(ORDER_PAY_FINISH);
        }
        //如果是小程序或APP 先获取用户openid
        MemberUserDO userDO = memberUserService.getUser(uid);
        if (PayTypeEnum.WEIXIN_APPLET.getValue().equals(param.getPaytype())) {
            //小程序支付需要openid
            if (Objects.isNull(userDO.getRoutineOpenid())) throw exception(USER_NOT_BINDING_WX_APPLET);
        }
        //根据type得到支付商户配置
        MerchantDetailsDO merchantDetailsDO = merchantDetailsService.getMerchantDetails(PayTypeEnum.toType(param.getPaytype()).getCode());
        PayContext payContext = new PayContext();
        Map<String, String> packageParams = new HashMap<>();
        if (param.getPaytype().contains(PayTypeEnum.ALI.getValue())) {
            aliPay(orderInfo, param, packageParams);
            updatePayInfo(orderInfo,packageParams);
        }else if(param.getPaytype().contains(PayTypeEnum.WEIXIN.getValue())){
            packageParams =  payContext.selectPayWay(PayTypeEnum.WEIXIN.getValue(),
                    new PayParam(orderInfo.getOrderId(), orderInfo.getPayPrice(), userDO.getRoutineOpenid(), ServletUtils.getClientIP(),
                            param.getPaytype(), "Yshop商城", merchantDetailsDO));
            updatePayInfo(orderInfo,packageParams);
        }else if(param.getPaytype().contains(PayTypeEnum.YUE.getValue())){
            yuePay(param.getUni(),uid);
        }
        // 异步统计
        asyncStoreOrderService.orderData(uid);
        return packageParams;
    }

    private void updatePayInfo(AppStoreOrderQueryVo orderInfo, Map<String, String> packageParams){
        PayInfo payInfo = new PayInfo();
        payInfo.setOrderId(orderInfo.getOrderId());
        payInfo.setOut_trade_no(packageParams.get("out_trade_no"));
        payInfo.setTransaction_id(packageParams.get("transaction_id"));
        //更新订单支付信息
        LambdaQueryWrapper<StoreOrderDO> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(StoreOrderDO::getOrderId, orderInfo.getOrderId());
        StoreOrderDO storeOrder = new StoreOrderDO();
        storeOrder.setPayInfo(JsonUtils.toJsonString(payInfo));
        this.update(storeOrder, wrapper);
    }

    private void aliPay(AppStoreOrderQueryVo orderInfo, AppPayParam param, Map<String, String> packageParams ){
        if(PayTypeEnum.ALI_H5.getValue().equals(param.getPaytype())){
            MerchantPayOrder payOrder = new MerchantPayOrder("1", "WAP", "支付宝H5商品购买",
                    "h5商品购买", orderInfo.getPayPrice(), param.getUni()+"-"+ RandomStringUtil.getRandomCode(3,0)+"H5");
            String str  = manager.toPay(payOrder);
            log.info(str);
           // packageParams.put("data",manager.toPay(payOrder));
        }else if(PayTypeEnum.ALI_APP.getValue().equals(param.getFrom())){
            MerchantPayOrder payOrder = new MerchantPayOrder("1", "APP", "支付宝APP商品购买",
                    "支付宝APP5商品购买", orderInfo.getPayPrice(), param.getUni()+"-"+ RandomStringUtil.getRandomCode(3,0)+"APP");
          //  packageParams.put("data",manager.app(payOrder));
        }
    }

    @Override
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public void wxPayNotify(HttpServletRequest request, HttpServletResponse response) throws Exception {
        log.info("进入微信支付回调");
        String xmlMsg = HttpKit.readData(request);
        log.info("微信回调通知信息" + xmlMsg);
        if (StringUtils.isEmpty(xmlMsg)) {
            log.info("回调接口内容为空！");
            return;
        }
        Map<String, String> resultMap = PaymentKit.xmlToMap(xmlMsg);
        //验签
        MerchantDetailsDO merchantDetailsDO = merchantDetailsService.getMerchantDetails("4");
        boolean validSignResult = PaymentKit.verifyNotify(resultMap, merchantDetailsDO.getKeyPrivate());
        log.info("验签结果{}", validSignResult);
        if (!MapUtils.isEmpty(resultMap)) {
            if (resultMap.get("return_code").equals("SUCCESS")) {
                String orderNo = resultMap.get("out_trade_no");
                log.info("回调out_trade_no=" + orderNo);
                log.info("回调transaction_id=" + resultMap.get("transaction_id"));
                //截取订单编号
                String[] split = orderNo.split("-");
                if (split.length > 0) {
                    String orderFormId = split[0];
                    if (!StringUtils.isEmpty(orderFormId)) {
                        LambdaQueryWrapper<StoreOrderDO> wrapper = new LambdaQueryWrapper<>();
                        wrapper.and(
                                i -> i.eq(StoreOrderDO::getOrderId, orderFormId).or().eq(StoreOrderDO::getUnique, orderFormId).or()
                                        .eq(StoreOrderDO::getExtendOrderId, orderFormId));
                        StoreOrderDO orderInfo = storeOrderMapper.selectOne(wrapper);
                        if (orderInfo == null) {
                            log.info("订单已经取消或删除");
                            String result = "<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OK]]></return_msg></xml>";
                            response.getWriter().write(result);
                        }
                        //判断订单装态，如果已支付说明为重复回调，丢弃
                        assert orderInfo != null;
                        if (OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue().equals(orderInfo.getPaid())) {
                            log.info("订单【{}】已经支付完成", orderInfo.getOrderId());
                            String result = "<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OK]]></return_msg></xml>";
                            response.getWriter().write(result);
                        }
                        //判断金额是否一致
                        BigDecimal totalFee = new BigDecimal(resultMap.get("total_fee"));
                        PayInfo payInfo = JsonUtils.parseObject(orderInfo.getPayInfo(), PayInfo.class);
                        log.info(totalFee + ":" + orderInfo.getPayPrice().multiply(BigDecimal.valueOf(100)));
                        if (!(totalFee.compareTo(orderInfo.getPayPrice().multiply(BigDecimal.valueOf(100))) == 0)) {
                            log.info("支付金额与订单金额不一致，请查询相关订单信息与客户确认！");
//                            throw exception(STORE_ORDER_PAY_FEE_ERROR);
                            //最简单做法 不一致退还支付金额,订单装态不变
                            assert payInfo != null;
                            Map map = new WxPayServiceUtils().refund(resultMap.get("transaction_id"), payInfo.getOut_refund_no(), orderInfo.getTotalPrice(), totalFee, merchantDetailsDO);
                            log.info("退款详情:" + map);
                            String result = "<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OK]]></return_msg></xml>";
                            response.getWriter().write(result);
                        }
                        //更新订单状态，与支付单据信息

                        assert payInfo != null;
                        payInfo.setTransaction_id(resultMap.get("transaction_id"));
                        LambdaQueryWrapper<StoreOrderDO> updateWrapper = new LambdaQueryWrapper<>();
                        updateWrapper.eq(StoreOrderDO::getOrderId, orderFormId);
                        StoreOrderDO storeOrder = new StoreOrderDO();
                        storeOrder.setPayInfo(JsonUtils.toJsonString(payInfo));
                        this.update(storeOrder, updateWrapper);
                        //支付完成回调的逻辑 修改订单装态等
                        this.paySuccess(orderFormId, PayTypeEnum.WEIXIN.getValue());
                    }
                }
            }
        } else {
            log.info("map为null");
        }
        log.info("微信小程序支付回调成功");
        String result = "<xml><return_code><![CDATA[SUCCESS]]></return_code><return_msg><![CDATA[OK]]></return_msg></xml>";
        response.getWriter().write(result);
    }

    /**
     * 余额支付
     *
     * @param orderId 订单号
     * @param uid     用户id
     */
    @Override
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public void yuePay(String orderId, Long uid) {
        AppStoreOrderQueryVo orderInfo = getOrderInfo(orderId, uid);
        if (ObjectUtil.isNull(orderInfo)) {
            throw exception(STORE_ORDER_NOT_EXISTS);
        }

        if (OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue().equals(orderInfo.getPaid())) {
            throw exception(ORDER_PAY_FINISH);
        }

        AppUserQueryVo userInfo = memberUserService.getAppUser(uid);

        if (userInfo.getNowMoney().compareTo(orderInfo.getPayPrice()) < 0) {
            throw exception(PAY_YUE_NOT);
        }

        memberUserService.decPrice(uid, orderInfo.getPayPrice());

        //支付成功后处理
        this.paySuccess(orderInfo.getOrderId(), PayTypeEnum.YUE.getValue());
    }


    /**
     * 支付成功后操作
     *
     * @param orderId 订单号
     * @param payType 支付方式
     */
    @Override
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public void paySuccess(String orderId, String payType) {
        AppStoreOrderQueryVo orderInfo = getOrderInfo(orderId, null);
        LambdaQueryWrapper<StoreOrderDO> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(StoreOrderDO::getOrderId, orderId);
        StoreOrderDO storeOrder = new StoreOrderDO();
        storeOrder.setPaid(OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue());
        storeOrder.setPayType(payType);
        storeOrder.setPayTime(LocalDateTime.now());
        this.update(storeOrder, wrapper);

        //增加用户购买次数
        memberUserService.incPayCount(orderInfo.getUid());
        //增加状态
        storeOrderStatusService.create(orderInfo.getUid(), orderInfo.getId(), OrderLogEnum.PAY_ORDER_SUCCESS.getValue(),
                OrderLogEnum.PAY_ORDER_SUCCESS.getDesc());


        MemberUserDO userInfo = memberUserService.getUser(orderInfo.getUid());
        //增加流水
        String payTypeMsg = PayTypeEnum.WEIXIN.getDesc();
        if (PayTypeEnum.YUE.getValue().equals(payType)) {
            payTypeMsg = PayTypeEnum.YUE.getDesc();
        } else if (PayTypeEnum.ALI.getValue().equals(payType)) {
            payTypeMsg = PayTypeEnum.ALI.getDesc();
        }
        billService.expend(userInfo.getId(), "购买商品",
                BillDetailEnum.CATEGORY_1.getValue(),
                BillDetailEnum.TYPE_3.getValue(),
                orderInfo.getPayPrice().doubleValue(), userInfo.getNowMoney().doubleValue(),
                payTypeMsg + orderInfo.getPayPrice() + "元购买商品");

        //发送消息队列进行推送消息
        if (userInfo.getLoginType().equals(AppFromEnum.ROUNTINE.getValue())) {
            weixinNoticeProducer.sendNoticeMessage(orderInfo.getUid(), WechatTempateEnum.PAY_SUCCESS.getValue(),
                    WechatTempateEnum.SUBSCRIBE.getValue(), orderId,
                    orderInfo.getPayPrice().toString(), "", "", "");
        } else if (userInfo.getLoginType().equals(AppFromEnum.WECHAT.getValue())) {
            weixinNoticeProducer.sendNoticeMessage(orderInfo.getUid(), WechatTempateEnum.PAY_SUCCESS.getValue(),
                    WechatTempateEnum.TEMPLATES.getValue(), orderId,
                    orderInfo.getPayPrice().toString(), "", "", "");
        }


    }

    /**
     * 减库存增加销量
     *
     * @param cartInfo 购物车
     */
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public void deStockIncSale(List<AppStoreCartQueryVo> cartInfo) {
        log.info("========减库存增加销量start=========");
        //对库存加锁
        RLock lock = redissonClient.getLock(STOCK_LOCK_KEY);
        if (lock.tryLock()) {
            try {
                for (AppStoreCartQueryVo storeCartVO : cartInfo) {
                    appStoreProductService.decProductStock(storeCartVO.getCartNum(), storeCartVO.getProductId(),
                            storeCartVO.getProductAttrUnique(), 0L, "");
                }
            } catch (Exception ex) {
                log.error("[deStockIncSale][执行异常]", ex);
                throw exception(new ErrorCode(999999, ex.getMessage()));
            } finally {
                lock.unlock();
            }
        }
    }


    /**
     * 订单列表
     *
     * @param uid   用户id
     * @param type  OrderStatusEnum
     * @param page  page
     * @param limit limit
     * @return list
     */
    @Override
    public List<AppStoreOrderQueryVo> orderList(Long uid, int type, int page, int limit) {
        LambdaQueryWrapper<StoreOrderDO> wrapper = new LambdaQueryWrapper<>();
        if (uid != null) {
            wrapper.eq(StoreOrderDO::getUid, uid);
        }
        wrapper.orderByDesc(StoreOrderDO::getId);


        switch (OrderStatusEnum.toType(type)) {
            case STATUS_ALL:
                break;
            //未支付
            case STATUS_WAIT_PAY:
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_UNPAID.getValue())
                        .eq(StoreOrderDO::getRefundStatus, OrderInfoEnum.REFUND_STATUS_NORMAL.getValue())
                        .eq(StoreOrderDO::getStatus, OrderInfoEnum.STATUS_DEFAULT.getValue());
                break;
            //待发货
            case STATUS_WAIT_SEND:
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue())
                        .eq(StoreOrderDO::getRefundStatus, OrderInfoEnum.REFUND_STATUS_NORMAL.getValue())
                        .eq(StoreOrderDO::getStatus, OrderInfoEnum.STATUS_DEFAULT.getValue());
                break;
            //待收货
            case STATUS_WAIT_RECEIVED:
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue())
                        .eq(StoreOrderDO::getRefundStatus, OrderInfoEnum.REFUND_STATUS_NORMAL.getValue())
                        .eq(StoreOrderDO::getStatus, OrderInfoEnum.STATUS_WAIT_RECEIVED.getValue());
                break;
            //待评价
            case STATUS_WAIT_EVALUATE:
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue())
                        .eq(StoreOrderDO::getRefundStatus, OrderInfoEnum.REFUND_STATUS_NORMAL.getValue())
                        .eq(StoreOrderDO::getStatus, OrderInfoEnum.STATUS_RECEIVED.getValue());
                break;
            //已完成
            case STATUS_FINISH:
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue())
                        .eq(StoreOrderDO::getRefundStatus, OrderInfoEnum.REFUND_STATUS_NORMAL.getValue())
                        .eq(StoreOrderDO::getStatus, OrderInfoEnum.STATUS_FINISHED.getValue());
                break;
            //退款中
            case STATUS_MINUS_BEING_REFUND:
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue())
                        .eq(StoreOrderDO::getRefundStatus, OrderInfoEnum.REFUND_STATUS_BEING_REFUNDED.getValue());
                break;
            //已退款
            case STATUS_MINUS_REFUNDED:
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_UNPAID.getValue())
                        .eq(StoreOrderDO::getRefundStatus, OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getValue());
                break;
            //退款
            case STATUS_MINUS_REFUND:
                String[] strs = {"1", "2"};
                wrapper.eq(StoreOrderDO::getPaid, OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue())
                        .in(StoreOrderDO::getRefundStatus, Arrays.asList(strs));
                break;
            default:
        }

        Page<StoreOrderDO> pageModel = new Page<>(page, limit);
        IPage<StoreOrderDO> pageList = storeOrderMapper.selectPage(pageModel, wrapper);
        List<AppStoreOrderQueryVo> list = StoreOrderConvert.INSTANCE.convertList01(pageList.getRecords());
        return list.stream().map(this::handleOrder).collect(Collectors.toList());
    }


    /**
     * 处理订单返回的状态
     *
     * @param order order
     * @return YxStoreOrderQueryVo
     */
    @Override
    public AppStoreOrderQueryVo handleOrder(AppStoreOrderQueryVo order) {
        LambdaQueryWrapper<StoreOrderCartInfoDO> wrapper = new LambdaQueryWrapper<>();
        wrapper.eq(StoreOrderCartInfoDO::getOid, order.getId());
        List<StoreOrderCartInfoDO> cartInfos = storeOrderCartInfoService.list(wrapper);

        List<AppStoreCartQueryVo> cartInfo = cartInfos.stream()
                .map(cart -> {
                    AppStoreCartQueryVo cartQueryVo = JSON.parseObject(cart.getCartInfo(), AppStoreCartQueryVo.class);
                    cartQueryVo.setUnique(cart.getUnique());
                    cartQueryVo.setIsReply(appStoreProductReplyService.replyCount(cart.getUnique()));
                    return cartQueryVo;
                })
                .collect(Collectors.toList());
        order.setCartInfo(cartInfo);

        StatusDto statusDTO = new StatusDto();
        if (OrderStatusEnum.STATUS_WAIT_PAY.getValue().equals(order.getPaid())) {
            //计算未支付到自动取消订 时间
            int offset = Integer.parseInt(String.valueOf(ShopConstants.ORDER_OUTTIME_UNPAY));
            log.info("time" + order.getCreateTime());
            LocalDateTime time = order.getCreateTime().plusMinutes(offset);
            statusDTO.set_class("nobuy");
            statusDTO.set_msg(StrUtil.format("请在{}前完成支付", time.format(DateTimeFormatter.ofPattern(FORMAT_YEAR_MONTH_DAY_HOUR_MINUTE_SECOND))));
            statusDTO.set_type(OrderStatusEnum.STATUS_WAIT_PAY.getValue().toString());
            long remainTime = time.toEpochSecond(ZoneOffset.ofHours(8)) * 1000 - System.currentTimeMillis();
            statusDTO.set_payRemainTime(String.valueOf(remainTime));
            statusDTO.set_title(OrderStatusEnum.STATUS_WAIT_PAY.getDesc());
        } else if (OrderInfoEnum.REFUND_STATUS_BEING_REFUNDED.getValue().equals(order.getRefundStatus())) {
            statusDTO.set_class("state-sqtk");
            statusDTO.set_msg("商家审核中,请耐心等待");
            statusDTO.set_type(OrderInfoEnum.STATUS_APPLY_REFUND.getValue().toString());
            statusDTO.set_title("申请退款中");
        } else if (OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getValue().equals(order.getRefundStatus())) {
            statusDTO.set_class("state-sqtk");
            statusDTO.set_msg("已为您退款,感谢您的支持");
            statusDTO.set_type(OrderInfoEnum.STATUS_REFUND_SUCCESS.getValue().toString());
            statusDTO.set_title(OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getDesc());
        } else if (OrderInfoEnum.STATUS_DEFAULT.getValue().equals(order.getStatus())) {
            // 拼团 todo
            if (order.getPinkId() <= 0) {
                statusDTO.set_class("state-nfh");
                statusDTO.set_msg("商家未发货,请耐心等待");
                statusDTO.set_type("1");
                statusDTO.set_title("未发货");
            }

        } else if (OrderInfoEnum.STATUS_WAIT_RECEIVED.getValue().equals(order.getStatus())) {
            statusDTO.set_class("state-ysh");
            statusDTO.set_msg("服务商已发货");
            statusDTO.set_type("2");
            statusDTO.set_title("待收货");
        } else if (OrderInfoEnum.STATUS_RECEIVED.getValue().equals(order.getStatus())) {
            statusDTO.set_class("state-ypj");
            statusDTO.set_msg("已收货,快去评价一下吧");
            statusDTO.set_type("3");
            statusDTO.set_title("待评价");
        } else if (OrderInfoEnum.STATUS_FINISHED.getValue().equals(order.getStatus())) {
            statusDTO.set_class("state-ytk");
            statusDTO.set_msg("交易完成,感谢您的支持");
            statusDTO.set_type("4");
            statusDTO.set_title("交易完成");
        }

        if (PayTypeEnum.WEIXIN.getValue().equals(order.getPayType())) {
            statusDTO.set_payType(PayTypeEnum.WEIXIN.getDesc());
        } else if (PayTypeEnum.YUE.getValue().equals(order.getPayType())) {
            statusDTO.set_payType(PayTypeEnum.YUE.getDesc());
        } else {
            statusDTO.set_payType(PayTypeEnum.INTEGRAL.getDesc());
        }

        order.set_status(statusDTO);

        // 查询是否发货
        StoreOrderStatusDO orderStatusDO =
                storeOrderStatusMapper.selectOne(new LambdaQueryWrapper<StoreOrderStatusDO>()
                        .eq(StoreOrderStatusDO::getOid, order.getId())
                        .eq(StoreOrderStatusDO::getChangeType, OrderLogEnum.DELIVERY_GOODS.getValue()));
        if (orderStatusDO != null) {
            order.setDeliveryTime(orderStatusDO.getChangeTime());
        }


        return order;
    }


    /**
     * 订单确认收货
     *
     * @param orderId 单号
     * @param uid     uid
     */
    @Override
    public void takeOrder(String orderId, Long uid) {
        AppStoreOrderQueryVo order = this.getOrderInfo(orderId, uid);
        if (ObjectUtil.isNull(order)) {
            throw exception(STORE_ORDER_NOT_EXISTS);
        }
        order = handleOrder(order);
        if (!OrderStatusEnum.STATUS_WAIT_RECEIVED.getValue().toString().equals(order.get_status().get_type())) {
            throw exception(ORDER_STATUS_ERROR);
        }

        StoreOrderDO storeOrder = new StoreOrderDO();
        storeOrder.setStatus(OrderInfoEnum.STATUS_RECEIVED.getValue());
        storeOrder.setId(order.getId());
        this.updateById(storeOrder);

        //增加状态
        storeOrderStatusService.create(order.getUid(), order.getId(), OrderLogEnum.TAKE_ORDER_DELIVERY.getValue(), OrderLogEnum.TAKE_ORDER_DELIVERY.getDesc());

        //奖励积分
        this.gainUserIntegral(order);

        //分销计算 todo

    }


    /**
     * 订单评价
     *
     * @param uid          用户ID
     * @param unique       订单orderCart唯一值
     * @param comment      评论内容
     * @param pics         图片
     * @param productScore 评分
     * @param serviceScore 评分
     */
    @Override
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public void orderComment(Long uid, String unique, String comment, String pics, String productScore,
                             String serviceScore) {
        StoreOrderCartInfoDO orderCartInfo = storeOrderCartInfoService
                .getOne(Wrappers.<StoreOrderCartInfoDO>lambdaQuery()
                        .eq(StoreOrderCartInfoDO::getUnique, unique));

        if (ObjectUtil.isEmpty(orderCartInfo)) {
            throw exception(COMMENT_PRODUCT_NOT_EXISTS);
        }

        long count = appStoreProductReplyService.count(Wrappers.<StoreProductReplyDO>lambdaQuery()
                .eq(StoreProductReplyDO::getOid, orderCartInfo.getOid())
                .eq(StoreProductReplyDO::getProductId, orderCartInfo.getProductId())
                .eq(StoreProductReplyDO::getUnique, unique));
        if (count > 0) {
            throw exception(COMMENT_PRODUCT_IN_EXISTS);
        }


        StoreProductReplyDO storeProductReply = StoreProductReplyDO.builder()
                .uid(uid)
                .oid(orderCartInfo.getOid())
                .productId(orderCartInfo.getProductId())
                .productScore(Integer.valueOf(productScore))
                .serviceScore(Integer.valueOf(serviceScore))
                .comment(comment)
                .pics(pics)
                .unique(unique)
                .build();

        appStoreProductReplyService.save(storeProductReply);
        //获取评价商品数量
        long replyCount = appStoreProductReplyService.count(new LambdaQueryWrapper<StoreProductReplyDO>().eq(StoreProductReplyDO::getOid, orderCartInfo.getOid()));
        //购买商品数量
        long cartCount = storeOrderCartInfoService.count(new LambdaQueryWrapper<StoreOrderCartInfoDO>().eq(StoreOrderCartInfoDO::getOid, orderCartInfo.getOid()));

        if (NumberUtil.equals(replyCount, cartCount)) {
            StoreOrderDO storeOrder = new StoreOrderDO();
            storeOrder.setStatus(OrderInfoEnum.STATUS_FINISHED.getValue());
            storeOrder.setId(orderCartInfo.getOid());
            this.updateById(storeOrder);
        }
        //增加状态
        storeOrderStatusService.create(uid, orderCartInfo.getOid(),
                OrderLogEnum.EVAL_ORDER.getValue(),
                OrderLogEnum.EVAL_ORDER.getDesc());
    }

    /**
     * 删除订单
     *
     * @param orderId 单号
     * @param uid     uid
     */
    @Override
    public void removeOrder(String orderId, Long uid) {
        AppStoreOrderQueryVo order = this.getOrderInfo(orderId, uid);
        if (order == null) {
            throw exception(STORE_ORDER_NOT_EXISTS);
        }
        order = handleOrder(order);
        if (!OrderInfoEnum.STATUS_FINISHED.getValue().equals(order.getStatus())) {
            throw exception(ORDER_NOT_DELETE);
        }

        this.removeById(order.getId());

        //增加状态
        storeOrderStatusService.create(uid, order.getId(),
                OrderLogEnum.REMOVE_ORDER.getValue(),
                OrderLogEnum.REMOVE_ORDER.getDesc());
    }

    /**
     * 未付款取消订单
     *
     * @param orderId 订单号
     * @param uid     用户id
     */
    @Override
    @Transactional(propagation = Propagation.REQUIRED, rollbackFor = Exception.class)
    public void cancelOrder(String orderId, Long uid) {
        log.info("订单取消：({})", orderId);
        AppStoreOrderQueryVo order = this.getOrderInfo(orderId, uid);
        if (ObjectUtil.isNull(order)) {
            throw exception(STORE_ORDER_NOT_EXISTS);
        }
        if (order.getPaid() != 0) {
            throw exception(ORDER_NOT_CANCEL);
        }
        //微信h5支付商户配置
        MerchantDetailsDO merchantDetailsDO = merchantDetailsService.getMerchantDetails("4");
        PayInfo payInfo = JsonUtils.parseObject(order.getPayInfo(), PayInfo.class);
        //取消之前要查询微信端是否支付完成如若由于网络原因造成两端不一致以微信端支付装态为准，已支付则不能取消，走退款逻辑
        // if (payInfo == null) throw exception(ORDER_PAYINFO_ERROR);
        // 有微信订单的数据关闭微信订单
        if (payInfo != null) {
            Map<String, String> map = PaymentApi.queryByOutTradeNo(merchantDetailsDO.getAppid(), merchantDetailsDO.getMchId(), merchantDetailsDO.getKeyPrivate(), payInfo.getOut_trade_no());
            log.info("查询微信订单状态：{}", map);
            //支付方也需要调用关闭订单接口
            if (Objects.equals(map.get(WxOrderResultEnum.TRADE_STATE.getValue()), WxOrderResultEnum.NOT_PAY.getValue())) {
                Map<String, String> closeOrderMap = PaymentApi.closeOrder(merchantDetailsDO.getAppid(), merchantDetailsDO.getMchId(), merchantDetailsDO.getKeyPrivate(), payInfo.getOut_trade_no());
                log.info("微信关闭订单：{}", closeOrderMap);
            }
        }

        this.regressionIntegral(order, 0);

        this.regressionStock(order, 0);

        // 取消订单退回优惠券
        appCouponRelationService.returnCoupon(order.getCouponId());
        this.regressionCoupon(order, 0);

        storeOrderMapper.deleteById(order.getId());

        // 异步统计
        asyncStoreOrderService.orderData(order.getUid());
    }

    /**
     * 确认订单退款
     *
     * @param orderId 单号
     * @param price   金额
     */
    @Override
    public void orderRefund(String orderId, BigDecimal price) throws Exception {

        AppStoreOrderQueryVo orderQueryVo = getOrderInfo(orderId, null);

        StoreOrderDO storeOrder = new StoreOrderDO();
        //生成退款单号
        PayInfo payInfo = JsonUtils.parseObject(orderQueryVo.getPayInfo(), PayInfo.class);
        if (payInfo == null) throw exception(ORDER_PAYINFO_ERROR);
        if (payInfo.getTransaction_id() == null)
            throw exception(ErrorCodeConstants.STORE_ORDER_REFUND_TRANSACTION_NULL_ERROR);
        String orderRefundNo = orderId + "-" + RandomStringUtil.getRandomCode(3, 0) + payInfo.getOut_trade_no().substring(payInfo.getOut_trade_no().lastIndexOf('-') + 1);
        payInfo.setOut_refund_no(orderRefundNo);
        //修改状态
        storeOrder.setId(orderQueryVo.getId());
        Map<String, String> packageParams = new HashMap<>();
        //根据支付类型不同退款不同
        if (PayTypeEnum.YUE.getValue().equals(orderQueryVo.getPayType())) {
            storeOrder.setRefundStatus(OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getValue());
            storeOrder.setRefundPrice(price);
            this.baseMapper.updateById(storeOrder);
            //退款到余额
            memberUserService.incMoney(orderQueryVo.getUid(), price);
            MemberUserDO memberUserDO = memberUserService.getById(orderQueryVo.getUid());

            //增加流水
            billService.income(orderQueryVo.getUid(), "商品退款", BillDetailEnum.CATEGORY_1.getValue(),
                    BillDetailEnum.TYPE_5.getValue(),
                    price.doubleValue(),
                    NumberUtil.add(price, memberUserDO.getNowMoney()).doubleValue(),
                    "订单退款到余额" + price + "元", orderQueryVo.getId().toString());
            //退款得仅仅退库存，其他得 不退比如优惠券等
            this.regressionStock(orderQueryVo, 1);

            storeOrderStatusService.create(orderQueryVo.getUid(), orderQueryVo.getId(),
                    OrderLogEnum.REFUND_ORDER_SUCCESS.getValue(), "退款给用户：" + price + "元");
        } else if (PayTypeEnum.WEIXIN.getValue().equals(orderQueryVo.getPayType())) {
            // 微信
            MerchantDetailsDO merchantDetailsDO = merchantDetailsService.getMerchantDetails("4");
            packageParams = new WxPayServiceUtils().refund(payInfo.getTransaction_id(), payInfo.getOut_refund_no(), orderQueryVo.getTotalPrice(), price, merchantDetailsDO);

            log.info("退款信息：{}", packageParams);
            //退款成功操作 应该在回调url中
            if (Objects.equals(packageParams.get("result_code"), "SUCCESS")) {
                payInfo.setRefund_id(packageParams.get("refund_id"));
                storeOrder.setRefundStatus(OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getValue());
                storeOrder.setRefundPrice(price);
                storeOrder.setPayInfo(JsonUtils.toJsonString(payInfo));
                this.baseMapper.updateById(storeOrder);
                //退款得仅仅退库存，其他得 不退比如优惠券等
                this.regressionStock(orderQueryVo, 1);
                storeOrderStatusService.create(orderQueryVo.getUid(), orderQueryVo.getId(),
                        OrderLogEnum.REFUND_ORDER_SUCCESS.getValue(), "退款给用户：" + price + "元");
            } else {
                throw exception(STORE_ORDER_REFUND_ERROR);
            }
        }
    }


    /**
     * 退回积分
     *
     * @param order 订单
     */
    private void regressionIntegral(AppStoreOrderQueryVo order, Integer type) {
        if (type == 0) {
            if (OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue().equals(order.getPaid())
                    || OrderStatusEnum.STATUS_MINUS_REFUNDED.getValue().equals(order.getStatus())) {
                return;
            }
        } else {
            if (!(OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue().equals(order.getPaid())
                    && OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getValue().equals(order.getRefundStatus()))) {
                return;
            }
        }

        if (order.getPayIntegral().compareTo(BigDecimal.ZERO) > 0) {
            order.setUseIntegral(order.getPayIntegral());
        }
        if (order.getUseIntegral().compareTo(BigDecimal.ZERO) <= 0) {
            return;
        }

        if (!OrderStatusEnum.STATUS_MINUS_REFUNDED.getValue().equals(order.getStatus())
                && !OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getValue().equals(order.getRefundStatus())
                && order.getBackIntegral().compareTo(BigDecimal.ZERO) > 0) {
            return;
        }

        MemberUserDO yxUser = memberUserService.getById(order.getUid());

        //增加积分
        BigDecimal newIntegral = NumberUtil.add(order.getUseIntegral(), yxUser.getIntegral());
        yxUser.setIntegral(newIntegral);
        memberUserService.updateById(yxUser);

        //增加流水
        billService.income(yxUser.getId(), "积分回退", BillDetailEnum.CATEGORY_2.getValue(),
                BillDetailEnum.TYPE_8.getValue(),
                order.getUseIntegral().doubleValue(),
                newIntegral.doubleValue(),
                "购买商品失败,回退积分" + order.getUseIntegral(), order.getId().toString());

        //更新回退积分
        StoreOrderDO storeOrder = new StoreOrderDO();
        storeOrder.setBackIntegral(order.getUseIntegral());
        storeOrder.setId(order.getId());
        this.updateById(storeOrder);
    }

    /**
     * 退回优惠券
     *
     * @param order 订单 todo
     */
    private void regressionCoupon(AppStoreOrderQueryVo order, Integer type) {
    }

    /**
     * 退回库存
     *
     * @param order 订单
     */
    private void regressionStock(AppStoreOrderQueryVo order, Integer type) {
        if (type == 0) {
            if (OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue().equals(order.getPaid())
                    || OrderStatusEnum.STATUS_MINUS_REFUNDED.getValue().equals(order.getStatus())) {
                return;
            }
        } else {
            if (!(OrderInfoEnum.PAY_STATUS_HAVE_PAID.getValue().equals(order.getPaid())
                    && OrderInfoEnum.REFUND_STATUS_HAVE_REFUNDED.getValue().equals(order.getRefundStatus()))) {
                return;
            }
        }
        LambdaQueryWrapper<StoreOrderCartInfoDO> wrapper = new LambdaQueryWrapper<>();
        wrapper.in(StoreOrderCartInfoDO::getCartId, Arrays.asList(order.getCartId().split(",")));

        List<StoreOrderCartInfoDO> cartInfoList = storeOrderCartInfoService.list(wrapper);
        for (StoreOrderCartInfoDO cartInfo : cartInfoList) {
            AppStoreCartQueryVo cart = JSONObject.parseObject(cartInfo.getCartInfo()
                    , AppStoreCartQueryVo.class);
            appStoreProductService.incProductStock(cart.getCartNum(), cart.getProductId()
                    , cart.getProductAttrUnique(), 0L, null);

        }
    }


    /**
     * 奖励积分
     *
     * @param order 订单
     */
    private void gainUserIntegral(AppStoreOrderQueryVo order) {
        if (order.getGainIntegral().compareTo(BigDecimal.ZERO) > 0) {
            MemberUserDO user = memberUserService.getUser(order.getUid());

            BigDecimal newIntegral = NumberUtil.add(user.getIntegral(), order.getGainIntegral());
            user.setIntegral(newIntegral);
            user.setId(order.getUid());
            memberUserService.updateById(user);

            //增加流水
            billService.income(user.getId(), "购买商品赠送积分", BillDetailEnum.CATEGORY_2.getValue(),
                    BillDetailEnum.TYPE_9.getValue(),
                    order.getGainIntegral().doubleValue(),
                    newIntegral.doubleValue(),
                    "购买商品赠送" + order.getGainIntegral() + "积分", order.getId().toString());
        }
    }


    /**
     * 计算奖励的积分
     *
     * @param cartInfo cartInfo
     * @return double
     */
    private BigDecimal getGainIntegral(List<AppStoreCartQueryVo> cartInfo) {
        BigDecimal gainIntegral = BigDecimal.ZERO;
        for (AppStoreCartQueryVo cart : cartInfo) {
            if (cart.getCombinationId() > 0 || cart.getSeckillId() > 0 || cart.getBargainId() > 0) {
                continue;
            }
            BigDecimal cartInfoGainIntegral = BigDecimal.ZERO;
            Double gain = cart.getProductInfo().getGiveIntegral().doubleValue();
            if (gain > 0) {
                cartInfoGainIntegral = NumberUtil.round(NumberUtil.mul(cart.getCartNum(), gain), 2);
            }
            gainIntegral = NumberUtil.add(gainIntegral, cartInfoGainIntegral);
        }
        return gainIntegral;
    }


    /**
     * 订单检测
     *
     * @param uid   uid
     * @param key   缓存值
     * @param param ComputeOrderParam
     * @return map
     */
    private Map<String, Object> check(Long uid, String key, AppComputeOrderParam param) {
        Map<String, Object> map = Maps.newHashMap();
        if (StrUtil.isBlank(key)) {
            throw exception(PARAM_ERROR);
        }
        AppStoreOrderQueryVo storeOrder = this.getOrderInfo(key, uid);
        if (ObjectUtil.isNotNull(storeOrder)) {

            OrderExtendDto orderExtendDTO = OrderExtendDto.builder()
                    .key(key)
                    .orderId(storeOrder.getOrderId())
                    .build();
            map.put("status", OrderLogEnum.EXTEND_ORDER.getValue());
            map.put("result", orderExtendDTO);
            map.put("msg", OrderLogEnum.EXTEND_ORDER.getDesc());
        }


        return map;
    }


    /**
     * 获取订单价格
     *
     * @param cartInfo 购物车列表
     * @return PriceGroupDto
     */
    private PriceGroupDto getOrderPriceGroup(List<AppStoreCartQueryVo> cartInfo, UserAddressDO userAddress, Long couponId) {

        BigDecimal storePostage;
        BigDecimal storeFreePostage = BigDecimal.ZERO;
        BigDecimal costPrice = this.getOrderSumPrice(cartInfo, "truePrice");//获取订单成本价
        BigDecimal payIntegral = BigDecimal.ZERO;
        BigDecimal couponPrice = BigDecimal.ZERO;

        if (couponId == null || couponId != -1l) {
            Map<Long, List<AppStoreCartQueryVo>> cartInfoMap =
                    cartInfo.stream().collect(Collectors.groupingBy(AppStoreCartQueryVo::getProductId));
            List<CartCouponDto> cartCouponDtoList = new ArrayList<>();
            for (List<AppStoreCartQueryVo> queryVos : cartInfoMap.values()) {
                BigDecimal amount = BigDecimal.ZERO;
                for (AppStoreCartQueryVo appStoreCartQueryVo : queryVos) {
                    amount = amount.add(appStoreCartQueryVo.getTruePrice()
                            .multiply(BigDecimal.valueOf(appStoreCartQueryVo.getCartNum())));
                }
                cartCouponDtoList.add(CartCouponDto.builder().productId(queryVos.get(0).getProductId()).price(amount).build());
            }
            List<CartCouponVO> cartCouponVOList = appCouponRelationService.searchCartCoupon(cartCouponDtoList, couponId);
            // 默认优惠券
            if (CollectionUtils.isNotEmpty(cartCouponVOList)) {
                CartCouponVO defaultCoupon = cartCouponVOList.get(0);
                couponPrice = defaultCoupon.getDiscountAmount();
                couponId = defaultCoupon.getDetailId();
            }
        }


        // this.getOrderSumPrice(cartInfo, "payIntegral");//获取订单需要的积分

        //运费模板
        storePostage = this.handlePostage(cartInfo, userAddress);

        BigDecimal totalPrice = costPrice.add(storePostage).subtract(couponPrice);//获取订单总金额

        PriceGroupDto priceGroupDTO = new PriceGroupDto();
        priceGroupDTO.setStorePostage(storePostage);
        priceGroupDTO.setStoreFreePostage(storeFreePostage);
        priceGroupDTO.setTotalPrice(totalPrice);
        priceGroupDTO.setCostPrice(costPrice);
        priceGroupDTO.setPayIntegral(payIntegral);
        priceGroupDTO.setCouponPrice(couponPrice);
        priceGroupDTO.setCouponId(couponId);
        return priceGroupDTO;
    }

    /**
     * 获取某字段价格
     *
     * @param cartInfo 购物车
     * @param key      key值
     * @return Double
     */
    private BigDecimal getOrderSumPrice(List<AppStoreCartQueryVo> cartInfo, String key) {
        BigDecimal sumPrice = BigDecimal.ZERO;

        if ("truePrice".equals(key)) {
            for (AppStoreCartQueryVo storeCart : cartInfo) {
                sumPrice = NumberUtil.add(sumPrice, NumberUtil.mul(storeCart.getCartNum(), storeCart.getTruePrice()));
            }
        } else if ("costPrice".equals(key)) {
            for (AppStoreCartQueryVo storeCart : cartInfo) {
                sumPrice = NumberUtil.add(sumPrice, NumberUtil.mul(storeCart.getCartNum(), storeCart.getCostPrice()));
            }
        } else if ("payIntegral".equals(key)) {
            for (AppStoreCartQueryVo storeCart : cartInfo) {
                if (storeCart.getProductInfo().getAttrInfo() != null && storeCart.getProductInfo().getAttrInfo().getIntegral() != null) {
                    sumPrice = NumberUtil.add(sumPrice,
                            NumberUtil.mul(storeCart.getCartNum(), storeCart.getProductInfo().getAttrInfo().getIntegral()));
                }

            }
        }

        return sumPrice;
    }


    /**
     * 根据运费模板算法返回邮费
     *
     * @param cartInfo    购物车
     * @param userAddress 地址
     * @return double
     */
    private BigDecimal handlePostage(List<AppStoreCartQueryVo> cartInfo, UserAddressDO userAddress) {
        BigDecimal storePostage = BigDecimal.ZERO;
        if (userAddress != null) {
            if (userAddress.getCityId() == null) {
                return storePostage;
            }
            //城市包括默认
            int cityId = userAddress.getCityId();
            List<Integer> cityIdList = new ArrayList<>();
            cityIdList.add(cityId);
            cityIdList.add(0);

            List<AppStoreProductRespVo> storeProductVOList = cartInfo
                    .stream()
                    .map(AppStoreCartQueryVo::getProductInfo)
                    .collect(Collectors.toList());
            List<Integer> tempIdS = storeProductVOList
                    .stream()
                    .map(AppStoreProductRespVo::getTempId)
                    .collect(Collectors.toList());


            //获取商品用到的运费模板
            List<ShippingTemplatesDO> shippingTemplatesList = shippingTemplatesService
                    .list(Wrappers.<ShippingTemplatesDO>lambdaQuery()
                            .in(ShippingTemplatesDO::getId, tempIdS));
            //获取运费模板区域列表按照城市排序
            List<ShippingTemplatesRegionDO> shippingTemplatesRegionList = shippingTemplatesRegionService
                    .list(Wrappers.<ShippingTemplatesRegionDO>lambdaQuery()
                            .in(ShippingTemplatesRegionDO::getTempId, tempIdS)
                            .in(ShippingTemplatesRegionDO::getCityId, cityIdList)
                            .orderByAsc(ShippingTemplatesRegionDO::getCityId));
            //提取运费模板类型
            Map<Integer, Integer> shippingTemplatesMap = shippingTemplatesList
                    .stream()
                    .collect(Collectors.toMap(ShippingTemplatesDO::getId,
                            ShippingTemplatesDO::getType));
            //提取运费模板有相同值覆盖
            Map<Integer, ShippingTemplatesRegionDO> shippingTemplatesRegionMap =
                    shippingTemplatesRegionList.stream()
                            .collect(Collectors.toMap(ShippingTemplatesRegionDO::getTempId,
                                    ShippingTemplatesRegionDO -> ShippingTemplatesRegionDO,
                                    (key1, key2) -> key2));


            Map<Integer, TemplateDto> templateDTOMap = new HashMap<>();
            for (AppStoreCartQueryVo storeCartVO : cartInfo) {
                Integer tempId = storeCartVO.getProductInfo().getTempId();

                //是否是固定邮费,没设置运费模板走固定
                if (tempId == 0) {
                    storePostage =
                            storePostage.add(storeCartVO.getProductInfo().getPostage()
                                    .multiply(BigDecimal.valueOf(storeCartVO.getCartNum())));
                    continue;
                    // return storeCartVO.getProductInfo().getPostage();
                }

                //根据模板类型获取相应的数量
                double num = 0d;
                if (ShippingTempEnum.BY_PIECE.getValue().equals(shippingTemplatesMap.get(tempId))) {
                    num = storeCartVO.getCartNum().doubleValue();
                } else if (ShippingTempEnum.BY_WEIGHT.getValue().equals(shippingTemplatesMap.get(tempId))) {
                    num = NumberUtil.mul(storeCartVO.getCartNum(),
                            storeCartVO.getProductInfo().getAttrInfo().getWeight()).doubleValue();
                } else if (ShippingTempEnum.BY_VOLUME.getValue().equals(shippingTemplatesMap.get(tempId))) {
                    num = NumberUtil.mul(storeCartVO.getCartNum(),
                            storeCartVO.getProductInfo().getAttrInfo().getVolume()).doubleValue();
                }

                ShippingTemplatesRegionDO shippingTemplatesRegion = shippingTemplatesRegionMap.get(tempId);
                BigDecimal price = NumberUtil.round(NumberUtil.mul(storeCartVO.getCartNum(),
                        storeCartVO.getTruePrice()), 2);
                if (!templateDTOMap.containsKey(tempId)) {
                    TemplateDto templateDTO = TemplateDto.builder()
                            .number(num)
                            .price(price)
                            .first(shippingTemplatesRegion.getFirst().doubleValue())
                            .firstPrice(shippingTemplatesRegion.getFirstPrice())
                            ._continue(shippingTemplatesRegion.getContinues().doubleValue())
                            .continuePrice(shippingTemplatesRegion.getContinuePrice())
                            .tempId(tempId)
                            .cityId(cityId)
                            .build();
                    templateDTOMap.put(tempId, templateDTO);
                } else {
                    TemplateDto templateDTO = templateDTOMap.get(tempId);
                    templateDTO.setNumber(templateDTO.getNumber() + num);
                    templateDTO.setPrice(NumberUtil.add(templateDTO.getPrice().doubleValue(), price));
                }


            }

            //处理包邮情况
            for (Map.Entry<Integer, TemplateDto> entry : templateDTOMap.entrySet()) {
                Integer mapKey = entry.getKey();
                TemplateDto mapValue = entry.getValue();

                long count = shippingTemplatesFreeService.count(Wrappers.<ShippingTemplatesFreeDO>lambdaQuery()
                        .eq(ShippingTemplatesFreeDO::getTempId, mapValue.getTempId())
                        .eq(ShippingTemplatesFreeDO::getCityId, mapValue.getCityId())
                        .le(ShippingTemplatesFreeDO::getNumber, mapValue.getNumber())
                        .le(ShippingTemplatesFreeDO::getPrice, mapValue.getPrice()));
                //满足包邮条件剔除
                if (count > 0) {
                    templateDTOMap.remove(mapKey);
                    break;
                }
            }

            //处理区域邮费
            boolean isFirst = false; //用来是否多个产品的标识 false表示数量大于1
            for (TemplateDto templateDTO : templateDTOMap.values()) {
                if (isFirst) {//首件
                    //只满足首件
                    if (Double.compare(templateDTO.getNumber(), templateDTO.getFirst()) <= 0) {
                        storePostage = NumberUtil.round(NumberUtil.add(storePostage,
                                templateDTO.getFirstPrice()), 2);
                    } else {
                        BigDecimal firstPrice = NumberUtil.add(storePostage, templateDTO.getFirstPrice());

                        if (templateDTO.get_continue() <= 0) {
                            storePostage = firstPrice;
                        } else {
                            //续件平均值且向上取整数
                            double average = Math.ceil(NumberUtil.div(NumberUtil.sub(templateDTO.getNumber(),
                                            templateDTO.getFirst()),
                                    templateDTO.get_continue().doubleValue()));
                            //最终邮费
                            storePostage = NumberUtil.add(firstPrice, NumberUtil.mul(average,
                                    templateDTO.getContinuePrice()));
                        }

                    }

                    isFirst = false;
                } else {
                    //多件直接在以前的基数继续续建
                    if (templateDTO.get_continue() > 0) {
                        //续件平均值且向上取整数
                        double average = Math.ceil(
                                NumberUtil.div(
                                        templateDTO.getNumber(),
                                        templateDTO.get_continue()
                                )
                        );
                        //最终邮费
                        storePostage = NumberUtil.add(storePostage.doubleValue(), NumberUtil.mul(average,
                                templateDTO.getContinuePrice()));
                    }
                }
            }
        }


        return storePostage;
    }


}
