package co.yixiang.yshop.module.product.dal.mysql.productcoupon;

import co.yixiang.yshop.framework.common.pojo.PageResult;
import co.yixiang.yshop.framework.mybatis.core.mapper.BaseMapperX;
import co.yixiang.yshop.framework.mybatis.core.query.LambdaQueryWrapperX;
import co.yixiang.yshop.module.product.controller.admin.productcoupon.vo.StoreProductCouponPageReqVO;
import co.yixiang.yshop.module.product.dal.dataobject.productcoupon.ProductCouponDO;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Param;
import java.util.List;

/**
 * 商品优惠券 Mapper
 *
 * @author moxiangrong
 */
@Mapper
public interface ProductCouponMapper extends BaseMapperX<ProductCouponDO> {


    default PageResult<ProductCouponDO> selectPage(StoreProductCouponPageReqVO reqVO) {
        LambdaQueryWrapperX<ProductCouponDO> wrapper = new LambdaQueryWrapperX<>();

        wrapper.likeIfPresent(ProductCouponDO::getCouponName, reqVO.getCouponName())
                .eqIfPresent(ProductCouponDO::getCouponType, reqVO.getCouponType())
                .eqIfPresent(ProductCouponDO::getCouponScope, reqVO.getCouponScope())
                .eqIfPresent(ProductCouponDO::getExpirationType, reqVO.getExpirationType())
                .eqIfPresent(ProductCouponDO::getReceiveType, reqVO.getReceiveType())
                .orderByDesc(ProductCouponDO::getId);

        return selectPage(reqVO, wrapper);

    }

    List<ProductCouponDO> receiveList(@Param("productId") Long productId);

}
