package co.yixiang.yshop.module.product.service.productcoupon;

import co.yixiang.yshop.module.product.controller.app.coupon.vo.AppCouponDetailRespVO;
import co.yixiang.yshop.module.product.convert.storeproductcoupon.StoreProductCouponConvert;
import co.yixiang.yshop.module.product.dal.dataobject.productcoupon.ProductCouponDO;
import co.yixiang.yshop.module.product.dal.mysql.productcoupon.ProductCouponMapper;
import co.yixiang.yshop.module.product.enums.coupon.CouponScopeEnum;
import co.yixiang.yshop.module.product.service.storeproduct.StoreProductService;
import com.baomidou.mybatisplus.core.toolkit.CollectionUtils;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import org.springframework.stereotype.Service;
import org.springframework.validation.annotation.Validated;

import javax.annotation.Resource;
import java.util.ArrayList;
import java.util.Comparator;
import java.util.List;
import java.util.stream.Collectors;

/**
 * App优惠券 Service 实现类
 *
 * @author moxiangrong
 */
@Service
@Validated
public class AppCouponServiceImpl extends ServiceImpl<ProductCouponMapper, ProductCouponDO> implements AppCouponService {

    @Resource
    private StoreProductService productService;


    @Override
    public List<AppCouponDetailRespVO> receiveList(Long productId) {
        List<ProductCouponDO> couponDOS = this.baseMapper.receiveList(productId);
        if (CollectionUtils.isEmpty(couponDOS)) return null;
        List<AppCouponDetailRespVO> couponDetailList = StoreProductCouponConvert.INSTANCE.convertList(couponDOS);
        couponDetailList = couponDetailList.stream()
                .sorted(Comparator.comparing(AppCouponDetailRespVO::getCouponType, Comparator.reverseOrder())
                        /*.thenComparing(AppCouponDetailRespVO::getDiscount, Comparator.naturalOrder())
                        .thenComparing(AppCouponDetailRespVO::getCouponValue, Comparator.reverseOrder())*/
                ).collect(Collectors.toList());
        return couponDetailList;
    }

    @Override
    public List<Long> getCouponProductList(Long id) {
        List<Long> productIdList = new ArrayList<>();
        ProductCouponDO couponDO = getById(id);
        if (CouponScopeEnum.PRODUCT.getValue().equals(couponDO.getCouponScope())) {
            String[] productIdArr = couponDO.getScopeValues().split(",");
            for (String s : productIdArr) productIdList.add(Long.parseLong(s));
        }
        return productIdList;
    }
}
