package co.yixiang.yshop.module.product.service.productcouponrelation;


import co.yixiang.yshop.module.product.controller.app.couponrelation.vo.CartCouponVO;
import co.yixiang.yshop.module.product.controller.app.couponrelation.vo.UserCouponVO;
import co.yixiang.yshop.module.product.dal.dataobject.productcouponrelation.ProductCouponRelationDO;
import co.yixiang.yshop.module.product.service.productcouponrelation.dto.CartCouponDto;
import com.baomidou.mybatisplus.extension.service.IService;

import java.util.List;


/**
 * App优惠券记录 Service 接口
 *
 * @author moxiangrong
 */
public interface AppCouponRelationService extends IService<ProductCouponRelationDO> {

    /**
     * 领取优惠券
     *
     * @param id 优惠券id
     * @return
     */
    void receiveCoupon(Long id);

    /**
     * 核销优惠券
     *
     * @param id 优惠券明细id
     * @return
     */
    void verificationCoupon(Long id);

    /**
     * 回退优惠券
     *
     * @param id 优惠券明细id
     * @return
     */
    void returnCoupon(Long id);

    /**
     * 查询用户已有优惠券
     *
     * @param type 查询类型
     * @param id 优惠券id
     * @return
     */
    List<UserCouponVO> searchUserCoupon(Integer type, Long id);

    /**
     * 查询购物车可用优惠券
     *
     * @param cartCouponDtoList 购物车信息
     * @return
     */
    List<CartCouponVO> searchCartCoupon(List<CartCouponDto> cartCouponDtoList, Long id);

}
