package co.yixiang.yshop.module.pay.strategy.type;

import co.yixiang.yshop.module.pay.controller.admin.merchantdetails.vo.PayParam;
import co.yixiang.yshop.module.pay.enums.PayTypeEnum;
import co.yixiang.yshop.module.pay.strategy.Pay;
import co.yixiang.yshop.module.pay.strategy.weixin.service.WxPayServiceUtils;
import org.springframework.stereotype.Component;

import java.util.Collections;
import java.util.Map;
import java.util.Objects;

public class WeChatPay implements Pay {

    @Override
    public Map<String, String> selectPayWay(String payCode, PayParam param) throws Exception {
        //根据微信type选择不同的支付 H5/APPLET/APP
        if (Objects.equals(param.getType(), PayTypeEnum.WEIXIN_H5.getValue()) ||
                Objects.equals(param.getType(), PayTypeEnum.WEIXIN_APP.getValue()) ||
                Objects.equals(param.getType(), PayTypeEnum.WEIXIN_APPLET.getValue())
        ) {
            return new WxPayServiceUtils().gotoPay(param);
        }
        return Collections.emptyMap();
    }
}
